﻿import * as THREE from "three";
import * as VerseThree from "verse-three";
import {
gui_setup
} from "./student_base"
import {
processStaticObject,
dynamicObject
} from "./student";


export const createSchoolWork = (_scene) =>{
  var isLowSpecMode = VerseThree.isLowSpecDevice();
  window.the_scene= _scene;
  processStaticObject();//静的オブジェクトの表示
  gui_setup(dynamicObject.param_define);//ui設定
  //動的処理を呼び出すスイッチの生成
  const switch_cube = new THREE.Mesh(
    new THREE.BoxGeometry( 1, 1, 1 ),
    new THREE.MeshStandardMaterial({color: 0x6699FF, roughness:0.5})  
  );
  if(!isLowSpecMode){
    switch_cube.castShadow = true;//影落とす
  }
  switch_cube.position.set(1, 0.5, 1);//スイッチの位置指定
  _scene.add(switch_cube);//シーンに追加
  
  //クリック時のイベント登録
  switch_cube.onSelectDown = () => {
    const task = new dynamicObject(switch_cube);
    task._start_by_local_user();
  };
  //リモート処理用メソッド設定
  switch_cube.doit= (param)=>{
    const task = new dynamicObject(switch_cube);
    task.start_by_remote_user(param);
  };
  return switch_cube;

}
