﻿import * as THREE from "three";
import * as VerseThree from "verse-three";
import {
gui_setup,
gui,
param_config
} from "./student_base"
import {
processStaticObject,
dynamicObject
} from "./student";


export const bind_float = (ename,_default,_min,_max,_step=1)=>{
  param_config[ename] = _default;
  return gui.add( ename , _min, _max, _step );
}


export const bind_event = (ename,func)=>{
  param_config[ename] = func;
  return gui.add( param_config, ename);
}

export const bind_color = (ename,default_color)=>{
  param_config[ename] = default_color;
  return gui.addColor( param_config, ename);
}



export const createSchoolWork = (_scene) =>{
  var isLowSpecMode = VerseThree.isLowSpecDevice();
  window.the_scene= _scene;
  processStaticObject();//静的オブジェクトの表示
  gui_setup(dynamicObject.param_define);//ui設定
  
  
  const base_obj = new THREE.Object3D();
  _scene.add(base_obj);//シーンに追加
  
  //guiのボタンで開始
  param_config["実行"] = () =>{
    const task = new dynamicObject(base_obj);
    task._start_by_local_user();
  }
  gui.add( param_config, '実行');
  
  //リモート処理用メソッド設定
  base_obj.doit= (param)=>{
    const task = new dynamicObject(base_obj);
    task.start_by_remote_user(param);
  };
  
  return base_obj;

}
