import * as THREE from "three";
export class trail{
  setup(scene,target,size,color,num){
    this.scene = scene;
    this.target = target;
    this._max_cube = num;
    this._arr_cube = [];
    this._arr_position_x = [];
    this._arr_position_y = [];
    this._arr_position_z = [];

    const pos = target.position;
    for(let i=0;i<num;i++){
      this._arr_position_x.push(pos.x);
      this._arr_position_y.push(pos.y);
      this._arr_position_z.push(pos.z);
    }
    
    this._instancedBoxes = new THREE.InstancedMesh(new THREE.BoxGeometry(size,size,size), new THREE.MeshStandardMaterial({ side: THREE.DoubleSide, color: color}), this._max_cube);
    this._instancedBoxes.layers.set(0);
    this._instancedBoxes.instanceMatrix.setUsage( THREE.DynamicDrawUsage );
    this._instancedBoxes.frustumCulled = false;

    this._matrix = new THREE.Matrix4();
    this._empty_mat = new THREE.Matrix4();
    this._dummy = new THREE.Object3D();
    this._instancedBoxes.instanceMatrix.needsUpdate = true
    scene.add(this._instancedBoxes);



  };
  
  tick(){
    //targetの位置をpushしてshiftしてく
    const pos = this.target.position;
    this._arr_position_x.push(pos.x);
    this._arr_position_y.push(pos.y);
    this._arr_position_z.push(pos.z);
    this._arr_position_x.shift();
    this._arr_position_y.shift();
    this._arr_position_z.shift();
    //console.log(this._arr_position_x);
    
    for(let i=0;i< this._max_cube;i++){
      const cx = this._arr_position_x[i];
      const cy = this._arr_position_y[i];
      const cz = this._arr_position_z[i];
      this._dummy.scale.set(1, 1, 1);
      this._dummy.position.set(cx, cy, cz);
      this._dummy.updateMatrix();
      this._instancedBoxes.setMatrixAt(i, this._dummy.matrix)
    }
    this._instancedBoxes.instanceMatrix.needsUpdate = true;
  }
  
  destroy(){
    this._instancedBoxes.material.dispose();
    this._instancedBoxes.geometry.dispose();
    this.scene.remove(this._instancedBoxes);
  }

}
